Attribute VB_Name = "modForms"
Option Explicit

Private Declare Function SetWindowLong Lib "User32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "User32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Private Declare Function RemoveMenu Lib "User32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function ModifyMenu Lib "User32" Alias "ModifyMenuA" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpString As Any) As Long
Private Declare Function GetMenuItemID Lib "User32" (ByVal hMenu As Long, ByVal nPos As Long) As Long

Public Declare Function SendMessage Lib "User32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Sub ReleaseCapture Lib "User32" ()
Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = 2



Private Type POINTAPI
  X As Long
  Y As Long
End Type

Private Type POINTS
  X  As Integer
  Y  As Integer
End Type

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Const WM_SYSCOMMAND = &H112
Private Const MOUSE_MOVE = &HF012
Private Const WM_LBUTTONUP = &H202
Private Const MF_BYPOSITION = &H400&
Private Const HWND_NOTOPMOST = -2
Private Const HWND_TOPMOST = -1
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_NOSIZE = 1
Private Const SWP_NOMOVE = 2
Private Const MF_BYCOMMAND = &H0&
Private Const MF_GRAYED = &H1&
Private Const SC_CLOSE = &HF060
Private Const WS_EX_TRANSPARENT = &H20&
Private Const GWL_EXSTYLE = (-20)

Public Sub CenterForm(frmIn As Form)
  ' Comments  : Centers the form on the screen
  ' Parameters: frmIn - form to center on the screen
  ' Returns   : Nothing

    On Error GoTo PROC_ERR

    frmIn.Move (Screen.Width - frmIn.Width) / 2, (Screen.Height - frmIn.Height) / 2

PROC_EXIT:
  Exit Sub

PROC_ERR:
    MsgBox "Error: " & Err.Number & ". " & Err.Description, vbSystemModal, "CenterForm"
  Resume PROC_EXIT

End Sub
Public Sub FormOnTop(frmIn As Form, ByVal fOnTop As Boolean)
  ' Comments  : Sets the form's style to be always on
  '             top, or to remove the always on top style
  ' Parameters: frmIn - the form to modify
  '             fOnTop - true to set the form to be always
  '             on top of other windows. Set to False to
  '             remove this attribute
  ' Returns   : Nothing

  '
  Dim lngState As Long
  
  On Error GoTo PROC_ERR

  If fOnTop Then
    lngState = HWND_TOPMOST
  Else
    lngState = HWND_NOTOPMOST
  End If
  
  SetWindowPos frmIn.hWnd, lngState, 0&, 0&, 0&, 0&, SWP_NOSIZE Or SWP_NOMOVE

PROC_EXIT:
  Exit Sub

PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, vbSystemModal, "FormOnTop"
  Resume PROC_EXIT

End Sub

Public Sub RemoveCancelMenuItem(frm As Form)
    Dim hSysMenu As Long
    'get the system menu for this form
    hSysMenu = GetSystemMenu(frm.hWnd, 0)
    'remove the close item
    Call RemoveMenu(hSysMenu, 6, MF_BYPOSITION)
    'remove the separator that was over the close item
    Call RemoveMenu(hSysMenu, 5, MF_BYPOSITION)
End Sub


